// Button
//
// Various button styles. Named by color for now, though I'd imagine at some point
// I'll settle into a hierarchy and organize these better. These rely on pseudoclasses,
// so `<input type="button">` is not available as a choice.
//
// .button:hover    - Not-so-subtle hovering.
// .button:active   - Not-so-subtle clicking.
// .button--white   - White button.
// .button--dark    - Dark button.
// .button--anakiwa - Cyan button.
// .button--deep-cerulean   - Dark aqua-ish button.
// .button--green   - Green button.
// .button--small   - Small button. Can be appended to any of the button classes.
//
// Markup:
// <a href="#" class="button {{modifier_class}}">Link Button</a>
// <button class="button {{modifier_class}}">Button Element</button>
//
// Style guide: Components.Button

@import '~breakpoint-sass/stylesheets/breakpoint';
@import './breakpoints';

@mixin buttonStyling(
  $background-color,
  $color,
  $border-color: lighten($background-color, 20%),
  $wall-color: darken($background-color, 20%),
  $wall-color-hover: $wall-color
  ) {
  background-color: $background-color;
  color: $color;

  box-shadow: 0 6px 3px 0 rgba($color-black, 0.2),
  inset 0 0 0 0 $border-color;

  &:hover:not([disabled]),
  &--hover {
    box-shadow: 0 9px 6px 2px rgba($color-black, 0.15),
    inset 0 0 0 4px $border-color;

    &:after {
      background-color: $wall-color-hover;
    }
  }

  &:active:not([disabled]) {
    box-shadow: 0 3px 3px 0 rgba($color-black, 0.2),
    inset 0 0 0 5px $border-color;
  }

  &:after {
    background: none;
    background-color: $wall-color;
    transition: background-color 0.2s, transform 0.2s;
  }
}

.button {
  display: inline-block;
  position: relative;
  margin-bottom: 7px;
  padding: 10px 30px 5px;
  transform: translateY(0);
  transition: background-color 0.2s, border-color 0.2s, transform 0.2s, box-shadow 0.2s;
  // border: 1px solid transparent;
  border: 0;
  background-color: transparent;
  color: $color-thunder;
  font-weight: 600;
  text-decoration: none;
  cursor: pointer;
  box-sizing: padding-box;
  appearance: none;
  outline: 0;

  @include breakpoint($all-small) {
    padding-left: 20px;
    padding-right: 20px;
  }

  &:after {
    position: absolute;
    bottom: -4px;
    left: 0;
    width: 100%;
    height: 4px;
    transform: scale(1, 1);
    transform-origin: center top;
    transition: transform 0.2s;
    content: '';
  }

  &:hover:not([disabled]) {
    transform: translateY(-3px);

    &:after {
      transform: scale(1, 1.75);
    }
  }

  &:active:not([disabled]) {
    transform: translateY(2px);
    transition: background-color 0.2s, border-color 0.2s, color 0.2s, transform 0s;

    &:after {
      transform: scale(1, 0.4);
      transition: transform 0s;
    }
  }

  &[disabled] {
    color: $color-tiara;
    cursor: default;
  }

  // @include buttonStyling($color-white, $color-thunder, darken($color-white, 5%));

  &--gray {
    @include buttonStyling($color-white, $color-thunder, #E9F2F2, darken($color-white, 20%), #66AFBA);
  }

  &--placeholder {
    @include buttonStyling($color-white, $color-botticelli, $color-lily-white, $color-lily-white);
  }

  &--primary {
    @include buttonStyling($color-white, $color-thunder, lighten($color-anakiwa, 10%), $color-deep-cerulean, darken($color-deep-cerulean, 10%));
    border: 2px solid $color-tiara;
    border-bottom-color: $color-deep-cerulean;

    &[disabled] {
      border-bottom: none;

      &:after {
        background-color: #A8A8A8;
      }
    }

    &:hover:not([disabled]),
    &:active:not([disabled]) {
      border: 2px solid lighten($color-anakiwa, 10%);
    }

    &:after {
      margin: 0 -2px;
      width: calc(100% + 4px);
      bottom: -5px;
    }
    
  }

  &--deep-cerulean {
    @include buttonStyling($color-deep-cerulean, $color-white, lighten($color-deep-cerulean, 10%), darken($color-deep-cerulean, 10%));
  }

  &--green {
    @include buttonStyling($color-de-york, $color-white, darken($color-de-york, 10%));

    &[disabled] {
      color: rgba($color-white, 0.5);
    }

  }

  &--large {
    font-size: 1.2em;
  }

  &--small {
    padding: 6px 15px 4px;
    font-size: 0.8em;
  }

  &--text {
    background-color: transparent;
    color: $color-thunder;
    box-shadow: 0 0 0 0 transparent,
    inset 0 0 0 0 darken($color-white, 5%);
    transform: translateY(2px);

    &:after {
      display: none;
    }

    &:hover:not([disabled]) {
      background-color: $color-white;
      box-shadow: 0 3px 5px 1px rgba($color-black, 0.2),
      inset 0 0 0 5px darken($color-white, 5%);
      transform: translateY(2px);
    }
  }

  &--text-danger {
    box-shadow: 0 0 0 0 transparent,
    inset 0 0 0 0 $color-brick-red;

    &:hover:not([disabled]) {
      background-color: $color-white;
      box-shadow: 0 3px 5px 1px rgba($color-black, 0.2),
      inset 0 0 0 5px $color-brick-red;
    }
  }

  &--text-center {
    padding: 7px;
  }

  &__icon {
    display: inline-block;
    width: 12px;
    height: 12px;
    margin-right: 5px;

    &--no-text {
      width: 16px;
      height: 16px;
      margin-right: 0;
    }

    &--active {
      fill: $color-de-york;
    }
  }
}
